<script>
import Vue from 'vue';
import { SolutionsVideoModal } from '../index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'ByIndustryCtaShowcase',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],

  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      modal: {
        open: null,
      },
    };
  },
  methods: {
    openModal(index) {
      this.modal.open = index;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = null;
    },
  },
});
</script>

<template>
  <section :id="data.largeCards.sectionAnchorId" class="slp-py-96">
    <SlpContainer>
      <SlpTypography
        v-if="data.largeCards.sectionHeader"
        class="section-header"
        tag="h2"
        variant="heading3-bold"
      >
        {{ data.largeCards.sectionHeader }}
      </SlpTypography>
      <div class="large-cards">
        <div
          v-for="card in data.largeCards.cards"
          :key="card.title"
          class="large-cards__card"
        >
          <div class="card-img-container">
            <img :src="card.img" alt="" />
          </div>
          <div class="card-content-container">
            <div>
              <SlpTypography
                v-if="card.title"
                tag="h3"
                class="slp-mb-16"
                variant="heading5-bold"
              >
                {{ card.title }}
              </SlpTypography>
              <SlpTypography tag="p" variant="body1">
                {{ card.subtitle }}
              </SlpTypography>
            </div>

            <SlpButton
              variant="tertiary"
              :href="card.button.href"
              :data-ga-name="card.button.dataGaName"
              :data-ga-location="card.button.dataGaLocation"
            >
              {{ card.button.text }}

              <SlpIcon
                class="learn-more-icon"
                name="chevron-lg-right"
                variant="product"
              />
            </SlpButton>
          </div>
        </div>
      </div>
      <SlpTypography
        v-if="data.videoCards.header"
        tag="h3"
        class="slp-my-24"
        variant="heading5-bold"
      >
        {{ data.videoCards.header }}
      </SlpTypography>
      <div class="video-cards">
        <button
          v-for="(card, index) in data.videoCards.cards"
          :key="card.title"
          :data-ga-name="card.dataGaName"
          :data-ga-location="card.dataGaLocation"
          class="video-cards__card"
          @click="openModal(index)"
        >
          <div>
            {{ card.title }}
          </div>
          <SlpIcon name="play-circle-outline" variant="marketing" size="sm" />
        </button>
      </div>
    </SlpContainer>
    <SolutionsVideoModal
      v-for="(video, index) in data.videoCards.cards"
      v-show="modal.open == index"
      :key="video.video.src"
      light-background
      :visible="modal.open == index"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          :videoid="getVimeoVideoId(createVideoSource(video.video.src))"
          :videotitle="video.video.title ?? 'Video player'"
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style lang="scss" scoped>
.video-iframe {
  aspect-ratio: 16 / 9;
  width: 600px;
  height: 337.5px;

  @media (max-width: $breakpoint-md) {
    width: 300px;
    height: 168.75px;
  }
}
.section-header {
  margin-bottom: 40px;
}
.large-cards {
  display: flex;
  flex-direction: column;
  gap: 40px;

  &__card {
    display: flex;
    justify-content: space-between;
    flex-wrap: nowrap;
    gap: 24px;
    height: auto;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      height: auto;
    }
  }
}
.card-img-container {
  border-radius: 4px;
  flex: 0 1 50%;
  display: block;
  position: relative;

  img {
    width: 100%;
    height: 100%;
  }
}

.card-content-container {
  border-radius: 4px;
  flex: 1 0 50%;
  padding: 32px;
  background: $color-surface-800;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}

.video-cards {
  display: flex;
  gap: 16px;
  flex-direction: column;
  &__card {
    padding: 16px;
    border: 1px solid $color-surface-300;
    font-weight: $font-weight-bold;
    border-radius: 4px;
    display: flex;
    text-align: left;
    align-items: center;
    justify-content: space-between;
    font-size: 14px;
    cursor: pointer !important;
    line-height: 22px;

    .slp-icon {
      width: 24px;
      height: 24px;
      transition: transform 0.2s ease-in-out;
    }

    &:hover {
      .slp-icon {
        transform: translateX(4px);
      }
    }
  }
}
</style>
